<?php

class Api_Vimeoplayer_Vimeoplayer extends Api_Service_Abstract{

    /**
     * Container mapper
     *
     * @var Application_Model_Mappers_ContainerMapper
     */
    private $_containerMapper = null;

    protected $_accessList = array(
        Tools_Security_Acl::ROLE_USER => array('allow' => array('get', 'post', 'put', 'delete')),
        Tools_Security_Acl::ROLE_SUPERADMIN => array('allow' => array('get', 'post', 'put', 'delete')),
        Tools_Security_Acl::ROLE_ADMIN => array('allow' => array('get', 'post', 'put', 'delete'))
    );

    public function init()
    {
        $this->_websiteHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('website');
        $this->_containerMapper = Application_Model_Mappers_ContainerMapper::getInstance();
    }

    public function getAction()
    {
        // TODO: Implement getAction() method.
    }

    public function postAction()
    {
        if($this->_request->isPost() && Tools_Security_Acl::isAllowed(Tools_Security_Acl::RESOURCE_PLUGINS)){
            $data = $this->_request->getParams();

            $tokenToValidate = $this->_request->getParam(Tools_System_Tools::CSRF_SECURE_TOKEN, false);
            $valid = Tools_System_Tools::validateToken($tokenToValidate, Vimeoplayer::VIMEOPLAYER_SECURE_TOKEN);
            if (!$valid) {
                exit;
            }

            $containerName = filter_var($this->_request->getParam('container'), FILTER_SANITIZE_STRING);
            $pageId = filter_var($this->_request->getParam('pageid'), FILTER_SANITIZE_NUMBER_INT);
            $type = ($pageId) ? Application_Model_Models_Container::TYPE_REGULARCONTENT : Application_Model_Models_Container::TYPE_STATICCONTENT;

            if ($pageId == 0) {
                $pageId = null;
            }

            $container = $this->_containerMapper->findByName($containerName, $pageId, $type);
            if (!$container instanceof Application_Model_Models_Container) {
                $container = new Application_Model_Models_Container();
                $container->setName($containerName)
                    ->setPageId($pageId)
                    ->setContainerType($type);
            }
            $container->setContent(Zend_Json::encode($data));
            return $this->_containerMapper->save($container);
        }
    }

    public function putAction()
    {
        // TODO: Implement putAction() method.
    }

    public function deleteAction()
    {
        // TODO: Implement deleteAction() method.
    }

}