<?php

class Vimeoplayer_Models_Mappers_VimeoplayerSearchWorkflowsMapper extends Application_Model_Mappers_Abstract{

    protected $_dbTable = 'Vimeoplayer_Models_Dbtables_VimeoplayerSearchWorkflowsDbtable';

    protected $_model = 'Vimeoplayer_Models_Models_VimeoplayerSearchWorkflowsModel';

    public function save($data)
    {
        if(!empty($data['videoId']) && !empty($data['videoName']) && !empty($data['content']) && !empty($data['lastUpdatedTime'])){
            $this->getDbTable()->insert($data);
            return true;
        }else{
            return false;
        }
    }

    public function findByVideoName($videoName)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('videoName LIKE ?', '%'.$videoName.'%');

        $select = $this->getDbTable()->getAdapter()->select()->from(array('pvsw' => 'plugin_vimeo_search_workflows'),
            array(
                'pvsw.videoId',
                'pvsw.videoName',
                'pvsw.content',
                'pvsw.lastUpdatedTime'
            ))
            ->where($where);

        return $this->getDbTable()->getAdapter()->fetchAssoc($select);
    }

    public function findByVideoId($videoId){
        $where = $this->getDbTable()->getAdapter()->quoteInto('videoId =?', $videoId);

        return $this->_findWhere($where)->toArray();

    }

    public function findVideosContainers($videoIds){
        $select = $this->getDbTable()->getAdapter()
            ->select()
            ->from(array('c' => 'container'), array(
                'c.name',
                'c.id'
            ))->where('c.name IN (?)', $videoIds);

        $result = $this->getDbTable()->getAdapter()->fetchPairs($select);
        return $result;

    }

}