<?php

class Vimeoplayer_Models_Mappers_VimeoplayerWorkflowsMapper extends Application_Model_Mappers_Abstract{

    protected $_dbTable = 'Vimeoplayer_Models_Dbtables_VimeoplayerWorkflowsDbtable';

    protected $_model = 'Vimeoplayer_Models_Models_VimeoplayerWorkflowsModel';

    public function save($model)
    {
        if (!$model instanceof $this->_model) {
            throw new Exceptions_SeotoasterException('Given parameter should be ' . $this->_model . ' instance');
        }
        $data = array(
            'channelId'         => $model->getChannelId(),
            'content'           => $model->getContent(),
            'lastUpdatedTime'   => $model->getLastUpdatedTime()
        );

        $channelId = $data['channelId'];
        $vimeoplayerWorkflows = $this->getByChannelId($channelId);
        if (!$vimeoplayerWorkflows instanceof Vimeoplayer_Models_Models_VimeoplayerWorkflowsModel) {
            $id = $this->getDbTable()->insert($data);

            return $model->setId($id);
        }
        $where = $this->getDbTable()->getAdapter()->quoteInto('channelId = ?', $channelId);
        $this->getDbTable()->update($data, $where);

        return $model;
    }

    public function getByChannelId($channelId)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('channelId = ?', $channelId);

        return $this->_findWhere($where);
    }

}